pipeline {
    agent any
    tools {
        nodejs "node"
    }
    stages {
        stage('increment version') {
            steps {
                script {
                    dir("app") {
                        sh "npm version minor"
                        def packageJson = readJSON file: 'package.json'
                        def version = packageJson.version
                        env.IMAGE_NAME = "$version-$BUILD_NUMBER"
                    }
                }
            }
        }
         stage('Run tests') {
            steps {
               script {
                   dir("app") {
                        sh "npm install"
                        sh "npm run test"
                }
            } 
        }
    }
        stage('Build and Push docker image') {
            steps {
                withCredentials([usernamePassword(credentialsId: 'docker-hub-repo', usernameVariable: 'USER', passwordVariable: 'PASS')]){
                     sh 'docker build -t obi007/demo-app:ndj-1.0 .'
                     sh 'echo $PASS | docker login -u $USER --password-stdin'
                     sh 'docker push obi007/demo-app:ndj-1.0'
                     }
                }
           }    
            stage('deploy to EC2') {
                steps {
                    script {
                       def shellCmd = "bash ./server-cmds.sh"
                       def ec2Instance = "ec2-user@13.40.122.206"

                       sshagent(['ec2-server-key']) {
                           sh "scp -o StrictHostKeyChecking=no server-cmds.sh ec2-user@13.40.122.206:/home/ec2-user"
                           sh "scp -o StrictHostKeyChecking=no docker-compose.yaml ec2-user@13.40.122.206:/home/ec2-user"
                           sh "ssh -o StrictHostKeyChecking=no ec2-user@13.40.122.206 ${shellCmd}"
                   }     
                }
            }
        }
    }
}
    

          
